# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.kpi import Kpi  # noqa: F401,E501
from swagger_server import util


class Kpis(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, forward_snr: Kpi=None, return_snr: Kpi=None, return_ber: Kpi=None, return_frequency_error: Kpi=None):  # noqa: E501
        """Kpis - a model defined in Swagger

        :param forward_snr: The forward_snr of this Kpis.  # noqa: E501
        :type forward_snr: Kpi
        :param return_snr: The return_snr of this Kpis.  # noqa: E501
        :type return_snr: Kpi
        :param return_ber: The return_ber of this Kpis.  # noqa: E501
        :type return_ber: Kpi
        :param return_frequency_error: The return_frequency_error of this Kpis.  # noqa: E501
        :type return_frequency_error: Kpi
        """
        self.swagger_types = {
            'forward_snr': Kpi,
            'return_snr': Kpi,
            'return_ber': Kpi,
            'return_frequency_error': Kpi
        }

        self.attribute_map = {
            'forward_snr': 'forward_snr',
            'return_snr': 'return_snr',
            'return_ber': 'return_ber',
            'return_frequency_error': 'return_frequency_error'
        }
        self._forward_snr = forward_snr
        self._return_snr = return_snr
        self._return_ber = return_ber
        self._return_frequency_error = return_frequency_error

    @classmethod
    def from_dict(cls, dikt) -> 'Kpis':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Kpis of this Kpis.  # noqa: E501
        :rtype: Kpis
        """
        return util.deserialize_model(dikt, cls)

    @property
    def forward_snr(self) -> Kpi:
        """Gets the forward_snr of this Kpis.


        :return: The forward_snr of this Kpis.
        :rtype: Kpi
        """
        return self._forward_snr

    @forward_snr.setter
    def forward_snr(self, forward_snr: Kpi):
        """Sets the forward_snr of this Kpis.


        :param forward_snr: The forward_snr of this Kpis.
        :type forward_snr: Kpi
        """

        self._forward_snr = forward_snr

    @property
    def return_snr(self) -> Kpi:
        """Gets the return_snr of this Kpis.


        :return: The return_snr of this Kpis.
        :rtype: Kpi
        """
        return self._return_snr

    @return_snr.setter
    def return_snr(self, return_snr: Kpi):
        """Sets the return_snr of this Kpis.


        :param return_snr: The return_snr of this Kpis.
        :type return_snr: Kpi
        """

        self._return_snr = return_snr

    @property
    def return_ber(self) -> Kpi:
        """Gets the return_ber of this Kpis.


        :return: The return_ber of this Kpis.
        :rtype: Kpi
        """
        return self._return_ber

    @return_ber.setter
    def return_ber(self, return_ber: Kpi):
        """Sets the return_ber of this Kpis.


        :param return_ber: The return_ber of this Kpis.
        :type return_ber: Kpi
        """

        self._return_ber = return_ber

    @property
    def return_frequency_error(self) -> Kpi:
        """Gets the return_frequency_error of this Kpis.


        :return: The return_frequency_error of this Kpis.
        :rtype: Kpi
        """
        return self._return_frequency_error

    @return_frequency_error.setter
    def return_frequency_error(self, return_frequency_error: Kpi):
        """Sets the return_frequency_error of this Kpis.


        :param return_frequency_error: The return_frequency_error of this Kpis.
        :type return_frequency_error: Kpi
        """

        self._return_frequency_error = return_frequency_error
